# - coding: utf-8 -

import os
import time
import shelve


class Archive(object):

	db_dir = ""
	db_path = ""

	db_name = ""
	
	data = None 
	
	max_tries = 10
	
	def __init__(self, dbname=""):
		
		self.db_name = dbname if dbname.endswith(".db") else (dbname + ".db")
		self.db_path = os.path.join(self.db_dir, self.db_name)
		
		self.load()


	def __setitem__(self, k, v):
		self.data[k] = v
	
	def __getitem__(self, k):
		return self.data[k]

	def __delitem__(self, k):
		del self.data[k]



	def __read_from_db(self):
		
		return dict(self.__open_file(flag="r") or {})


	def __open_file(self, **kargs):
		
		for x in xrange(self.max_tries):
			try:
				return shelve.open(self.db_path, **kargs)
			except:
				time.sleep(1)

		return None


	def save(self):
		
		d = self.__open_file()
		if d is None:
			return 1
		
		d.clear()
		d.update(self.data)
		
		d["last_save"] = time.strftime("%Y-%m-%d %H:%M:%S")
		d.close()
		
		return 0


	def load(self):

		self.data = {}
		self.data.update(self.__read_from_db())
		self.data["last_open"] = time.strftime("%Y-%m-%d %H:%M:%S")

		return self
	

	






